#ifndef _PLOTDSORESULT_H_
#define _PLOTDSORESULT_H_
#include "TROOT.h"
#include "TStyle.h"
#include "TFile.h"
#include "TTree.h"
#include "TH2F.h"
#include "TCanvas.h"
#include "TBox.h"
#include "TText.h"
#include "NovaDAQConventions/DAQConventions.h"
#include "DAQChannelMap/HardwareDisplay.h"
#include "OnlineMonitoring/util/HistoData.h"
#ifdef NOVACMAKE
#include "DSOResultPlotter/cxx/include/NovaTimeSeries.h"
#else
#include "DSOResultPlotter/NovaTimeSeries.h"
#endif
//using namespace DPL_NAMESPACE;
using namespace nova::detectorplotter;

//define Histogram and functions
void usage ( int argc, char* argv[] );
void doFEBMasks(std::string , std::string ,om::Detector_t);
void doPixelMasks(std::string , std::string ,om::Detector_t );
void doThresholds(std::string , std::string, om::Detector_t, TH2* =0);
void DrawHWOverlay(TCanvas*,TH2F*);
TH2F* DSOFEBEnableDET_dd = 0;
TH2F* DSOPixelEnableDET_dd = 0;
TH2F* DSOThresholdsDET_dd = 0;
TH2F* DSOFEBEnableDCM[15][12];
TH2F* DSOPixelEnableDCM[15][12];
TH2F* DSOThresholdsDCM[15][12];


#endif // _PLOTDSORESULT_H_

