////////////////////////////////////////////////////////////////////////
/// \file   NuePreselObj.h
/// \brief   Object collecting Nue Preselection variables
/// \author  Gavin Davies -gsdavies@iu.edu
////////////////////////////////////////////////////////////////////////
#ifndef NUEPRESELOBJ_H
#define NUEPRESELOBJ_H

namespace presel
{
  class NuePreselObj
  {
  public:
    
    NuePreselObj();
    ~NuePreselObj();

#ifndef __GCC_XML__

    void SetPassNuePresel(bool pass);  ///< holds pass/fail output of nue presel

    bool PassNuePresel() const;

#endif
    
  protected:
    
    bool fPassNuePresel;
    
  };
  
}

#endif // NUEPRESELOBJ_H
//////////////////////////////////////////////////////////////////////
