/////////////////////////////////////////////////////////////////////////
/// \brief   Simple module to determine matching data run number in MC file
/// \author  betancourt@umn.edu
/// \date
/////////////////////////////////////////////////////////////////////////
#ifndef DATARUNNUMINMC_H
#define DATARUNNUMINMC_H

#include <iostream>

namespace sumdata {
  
  class DataRunNumInMC {
  public: 
    DataRunNumInMC();
    ~DataRunNumInMC();
    
    void Print(std::ostream &stream);
    
    int run; //< run number
  };
  
}
#endif // DATARUNNUMINMC_H
////////////////////////////////////////////////////////////////////


