#include "CosRej/NueCosRej.h"

namespace cosrej{


  NueCosRej::NueCosRej():     
    fHitsPerPlane(-5.0),
    fProngTransMom(-5.0),
    fParticleShowerTransMom(-5.0),
    fPhotonShowerTransMom(-5.0),
    fStartDistToTop(-5.0),
    fStartDistToBottom(-5.0),
    fStartDistToFront(-5.0),
    fStartDistToBack(-5.0),
    fStartDistToWest(-5.0),
    fStartDistToEast(-5.0),
    fStopDistToTop(-5.0),
    fStopDistToBottom(-5.0),
    fStopDistToFront(-5.0),
    fStopDistToBack(-5.0),
    fStopDistToWest(-5.0),
    fStopDistToEast(-5.0),
    fStartMinDistToTop(-5.0),
    fStartMinDistToBottom(-5.0),
    fStartMinDistToFront(-5.0),
    fStartMinDistToBack(-5.0),
    fStartMinDistToWest(-5.0),
    fStartMinDistToEast(-5.0),
    fStopMinDistToTop(-5.0),
    fStopMinDistToBottom(-5.0),
    fStopMinDistToFront(-5.0),
    fStopMinDistToBack(-5.0),
    fStopMinDistToWest(-5.0),
    fStopMinDistToEast(-5.0),
    fProngDistToVtx(-5.0),
    fCosAngleToNextProng(-5.0),
    fProngMaxX(-5.0),
    fProngMaxY(-5.0),
    fProngMaxZ(-5.0),
    fProngMinX(-5.0),
    fProngMinY(-5.0),
    fProngMinZ(-5.0)
  {
  }// end of constructor

  //---------------------------------------------------------
  NueCosRej::~NueCosRej()
  {
  }

}// end of namespace cosrej
