#include "RecoBase/Cluster.h"
#include "CosRej/CosRejObj.h"
#include "CosRej/NueCosRej.h"

#include "art/Persistency/Common/Assns.h"
#include "art/Persistency/Common/Wrapper.h"
#include "art/Persistency/Common/Ptr.h"

template class std::vector<cosrej::CosRejObj>;
template class art::Ptr<cosrej::CosRejObj>;
template class std::vector<art::Ptr<cosrej::CosRejObj> >;
template class art::Assns<rb::Cluster, cosrej::CosRejObj, void>;
template class art::Assns<cosrej::CosRejObj, rb::Cluster, void>;

template class std::pair< rb::Cluster, cosrej::CosRejObj >;
template class std::pair< art::Ptr<rb::Cluster>, art::Ptr<cosrej::CosRejObj> >;
template class std::pair< cosrej::CosRejObj, rb::Cluster >;
template class std::pair< art::Ptr<cosrej::CosRejObj>, art::Ptr<rb::Cluster> >;

template class art::Wrapper< std::vector<cosrej::CosRejObj> >;
template class art::Wrapper<art::Assns<rb::Cluster, cosrej::CosRejObj, void> >;
template class art::Wrapper<art::Assns<cosrej::CosRejObj, rb::Cluster, void> >;


/* class templates for NueCosRej */

template class std::vector<cosrej::NueCosRej>;
template class art::Ptr<cosrej::NueCosRej>;
template class std::vector<art::Ptr<cosrej::NueCosRej> >;
template class art::Assns<rb::Cluster, cosrej::NueCosRej, void>;
template class art::Assns<cosrej::NueCosRej, rb::Cluster, void>;

template class std::pair< rb::Cluster, cosrej::NueCosRej >;
template class std::pair< art::Ptr<rb::Cluster>, art::Ptr<cosrej::NueCosRej> >;
template class std::pair< cosrej::NueCosRej, rb::Cluster >;
template class std::pair< art::Ptr<cosrej::NueCosRej>, art::Ptr<rb::Cluster> >;

template class art::Wrapper< std::vector<cosrej::NueCosRej> >;
template class art::Wrapper<art::Assns<rb::Cluster, cosrej::NueCosRej, void> >;
template class art::Wrapper<art::Assns<cosrej::NueCosRej, rb::Cluster, void> >;

