////////////////////////////////////////////////////////////////////////
// $Id: SimTrack.h,v 1.5 2011-10-19 20:31:56 brebel Exp $
//
// Definition of reco Track.
//
// \author $Author: brebel $
// \date   $Date: 2011-10-19 20:31:56 $
//
////////////////////////////////////////////////////////////////////////

#ifndef SIMTRACK_H
#define SIMTRACK_H

#include "RecoBase/Track.h"

namespace cheat {
  
  class SimTrack : public rb::Track{

  public:
    SimTrack();
    ~SimTrack();

 #ifndef __GCCXML__    
    int  PID() const { return fPID; }
    int TrackID() const { return fTrackID; }

    void SetPID(int pid) { fPID = pid; }
    void SetTrackID(int trackid) { fTrackID = trackid; }
 #endif

  private:
    int fPID; ///< Particle Data Group code for the particle
    int fTrackID; ///< Track ID for the particle
      
 };
}

#endif // SIMTRACK_H
