////////////////////////////////////////////////////////////////////////
// Class:       QePId
// Module Type: producer
// File:        QePId.cxx
//
// Generated at Tue Feb  5 10:29:24 2013 by Nicholas Raddatz using artmod
// from art v1_02_06.
////////////////////////////////////////////////////////////////////////
#include "QEEventFinder/QePId.h"


namespace qeef
{
  //......................................
  QePId::QePId()
    : rb::PID()
  {
    fMode = 0;
    SetNtrk(0);
    SetOffTrkE(0);
    SetEdiff(0);
    SetEdiffZ(0);
    SetDedx(0);
  }

  //......................................
  QePId::QePId(int pdg, double val)
    : rb::PID(pdg,val)
  {
    fMode = 0;
    SetNtrk(0);
    SetOffTrkE(0);
    SetEdiff(0);
    SetEdiffZ(0);
    SetDedx(0);
  }

  //......................................
  void    QePId::SetNtrk(int ntrks)
  {
    fNtrk = ntrks;
  }

  //......................................
  void    QePId::SetOffTrkE(double E)
  {
    fOffTrkE = E;
  }

  //......................................
  void    QePId::SetEdiff(double diff)
  {
    fEdiff = diff;
  }

  //......................................
  void    QePId::SetEdiffZ(double diffZ)
  {
    fEdiffZ = diffZ;
  }

  //......................................
  void    QePId::SetDedx(double Dedx)
  {
    fDedx = Dedx;
  }

  //......................................
  int     QePId::Mode() const
  {
    return fMode;
  }

  //......................................
  int     QePId::Ntrk() const
  {
    return fNtrk;
  }

  //......................................
  double  QePId::OffTrkE() const
  {
    return fOffTrkE;
  }

  //......................................
  double  QePId::Ediff() const
  {
    return fEdiff;
  }

  //......................................
  double  QePId::EdiffZ() const
  {
    return fEdiffZ;
  }

  //......................................
  double  QePId::Dedx() const
  {
    return fDedx;
  }

}
