////////////////////////////////////////////////////////////////////////////////
/// \file    PID.cxx
/// \brief   pdg code and pid value
/// \version $Id: PID.cxx,v 1.1 2012-08-14 23:52:02 raddatz Exp $
/// \author  raddatz@physics.umn.edu
////////////////////////////////////////////////////////////////////////////////
#include "RecoBase/PID.h"

namespace rb
{
  //.....................................................................

  PID::PID() :
    fPdg(0),
    fVal(0)
  {
  }

  //......................................................................

  PID::PID(int pdg, double  val) :
    fPdg(pdg),
    fVal(val)
  {
  }

  //......................................................................

} // end namespace rb
////////////////////////////////////////////////////////////////////////
