#include "art/Persistency/Common/Wrapper.h"
#include "art/Persistency/Common/Assns.h"
#include "art/Persistency/Common/Ptr.h"

#include <vector>

// NOvA includes
#include "RecoBase/CellHit.h"
#include "RecoBase/Vertex.h"
#include "RecoBase/Cluster.h"
#include "RecoJMShower/JMShower.h"
#include "RecoJMShower/EID.h"
//
// Only include objects that we would like to be able to put into the event.
// Do not include the objects they contain internally.
//

template class std::vector<jmshower::JMShower>;
template class art::PtrVector<jmshower::JMShower>;
template class art::Wrapper<art::PtrVector<jmshower::JMShower> >;
template class art::Wrapper< std::vector<jmshower::JMShower>       >;
template class std::pair< art::Ptr<jmshower::JMShower>,   art::Ptr<rb::CellHit> >;
template class std::pair< art::Ptr<rb::Vertex>,  art::Ptr<jmshower::JMShower>   >;
template class art::Assns<jmshower::JMShower,   rb::CellHit, void>;
template class art::Assns<rb::Vertex,  jmshower::JMShower,   void>;
template class art::Assns<jmshower::JMShower, rb::Cluster, void>;
template class art::Assns<jmshower::JMShower, rb::Prong, void>;
template class art::Assns<rb::Shower, rb::Prong, void>;
template class art::Assns<jmshower::EID, rb::Cluster, void>;
template class art::Assns<rb::Cluster, jmshower::EID, void>;
template class art::Assns<rb::Cluster, jmshower::JMShower, void>;
template class art::Assns<rb::Prong, jmshower::JMShower, void>;
template class art::Assns<rb::Prong, rb::Shower, void>;
template class art::Wrapper< art::Assns<jmshower::JMShower,   rb::CellHit, void> >;
template class art::Wrapper< art::Assns<rb::Vertex,  jmshower::JMShower,   void> >;
template class art::Wrapper< art::Assns<jmshower::JMShower, rb::Cluster,  void> >;
template class art::Wrapper< art::Assns<rb::Shower, rb::Prong,  void> >;
template class art::Wrapper< art::Assns<jmshower::JMShower, rb::Prong,  void> >;
template class art::Wrapper< art::Assns<jmshower::EID, rb::Cluster,  void> >;
template class art::Wrapper< art::Assns<rb::Cluster, jmshower::EID,  void> >;
template class art::Wrapper< art::Assns<rb::Cluster, jmshower::JMShower, void> >;
template class art::Wrapper< art::Assns<rb::Prong, jmshower::JMShower, void> >;
template class art::Wrapper< art::Assns<rb::Prong, rb::Shower, void> >;
template class std::vector<jmshower::EID>;
template class art::Ptr<jmshower::EID>;
template class std::vector<art::Ptr<jmshower::EID> >;
template class art::Wrapper< std::vector<jmshower::EID> >;
