////////////////////////////////////////////////////////////////////////
// \file    LID.cxx
// \brief   A pid object for electron identification based on Jianming Bian's 
//          original EID
// \version 
// \author  Alex Smith - smith@physics.umn.edu
////////////////////////////////////////////////////////////////////////
#include "ShowerLID/EventLID.h"
#include "TVector3.h"

namespace slid {

  //......................................

  EventLID::EventLID(int pdg, double val)
    : rb::PID(pdg, val),
      fPIDWithE(-5.0)
  {
  }// end of constructor

}// end of namespace slid
