void mlpPIDelecallEtot(Int_t ntrain= 600 ) {
//Author: Jianming Bian 
   double Elow = 0.0;
   double Ehigh = 5.0;
   double rsig = 1.0;
   double rbg = 0.9;
  
   TChain signal("lidtrain/fEvent");
   TChain background("lidtrain/fEvent");


  string line;
  ifstream inFile("/nova/ana/users/edniner/LIDTraining/round4/swaplist.txt");
  int scount = 0;
  if (inFile.is_open()){
    while (inFile.good()){
      getline(inFile,line);
      if (line == "") continue;
      //std::string test = line.substr(63,5);
      //if (atoi(test.c_str()) < fMinRun) continue;
      //if (atoi(test.c_str()) >= fMaxRun) continue;
      std::cout <<"Adding file: " << line << std::endl;
      signal.AddFile(line.c_str());
      scount++;
      if (scount >=151) break;
    }
    inFile.close();
  }
  ifstream inFile2("/nova/ana/users/edniner/LIDTraining/round4/nonswaplist.txt");
  int ncount = 0;
  if (inFile2.is_open()){
    while (inFile2.good()){
      getline(inFile2,line);
      if (line == "") continue;
      //std::string test = line.substr(63,5);
      //if (atoi(test.c_str()) < fMinRun) continue;
      //if (atoi(test.c_str()) >= fMaxRun) continue;
      std::cout <<"Adding file: " << line << std::endl;
      background.AddFile(line.c_str());
      ncount++;
      if (ncount >=301) break;
    }
    inFile2.close();
  }


   TCut MCNUECCQE = "evtTrueNuPdg==12&&(evtRwRand[0]>0&&evtRwRand[0]<evtRwProb[0])"; 
   TCut MCBKG = "(evtRwRand[2]>0&&evtRwRand[2]<evtRwProb[2])";
   TH1F* htruenue=new TH1F("htruenue","htruenue", 100,0, 5);
   TH1F* htruenupi0=new TH1F("htruenupi0","htruenupi0", 100,0, 5);
   signal.Draw("evtTrueNuEnergy>>htruenue",MCNUECCQE);
   background.Draw("evtTrueNuEnergy>>htruenupi0", MCBKG);

   double nsig =  htruenue->GetEntries();
   double nbkg =  htruenupi0->GetEntries();
   
   TCanvas *c0 = new TCanvas("c0","c0",200,10, 1200,600);
   c0->Divide(2,1);
   c0->cd(1);
   htruenue->Draw();
   c0->cd(2);
   htruenupi0->Draw();
   c0->Update();


   if (!gROOT->GetClass("TMultiLayerPerceptron")) {
      gSystem->Load("libMLP");
   }
   gSystem->Load("libRooFit");

   int    evtTrueNuCCNC;
   int    evtTrueNuMode;
   int    evtTrueNuPdg;
   double evtTrueNuEnergy;
   double evtTrueNuP4[4];
   double evtTrueNuVtx[3];


   double evtRwProb[20];
   double evtRwRand[20];

   int  evtRun;
   int  evtSRun;
   int  evtEvent;
   int evtNSlice;
   double evtPi0Mgg0;
   double evtPi0Mgg;
   double evtSh1Pi0Mgg;
   double evtSh1VtxGeV;
   double evtSh1CosTheta;
   double evtSh1Length;
   double evtPi0Eg1;
   double evtPi0Eg2;
   double evtPi0TrueDirMgg0;
   double evtPi0TrueDirMgg;
   double evtPi0StartDist;
   double evtPi0LineDist;

   double evtEtot0;
   double evtEtot;
   double evtSh1SumPt;

   double evtPEtot;
   double evtTrueEtot;

   double evtSh1Energy;
   double evtTotalRecoGeV;
   double evtSh1Gap;
   double evtSh1IsFid;
   double evtSh1P4[4];
   double evtSh1Start[3];
   double evtSh1DedxLLL[20];
   double evtSh1DedxLLT[20];
   double evtSh1NPlane;
   double evtSh1NMIPPlane;
   double evtSh2Energy;

   int evtSh1TruePdg;
   double evtSh1TrueDang;
   double evtSh1TrueEDang;

   Int_t type;


   signal.SetBranchAddress("evtTrueNuCCNC", &evtTrueNuCCNC);
   signal.SetBranchAddress("evtTrueNuMode", &evtTrueNuMode);
   signal.SetBranchAddress("evtTrueNuPdg", &evtTrueNuPdg);
   signal.SetBranchAddress("evtTrueNuEnergy", &evtTrueNuEnergy);
   signal.SetBranchAddress("evtTrueNuP4[4]", evtTrueNuP4);
   signal.SetBranchAddress("evtTrueNuVtx[3]",evtTrueNuVtx);

   signal.SetBranchAddress("evtRwProb[20]",evtRwProb);
   signal.SetBranchAddress("evtRwRand[20]",evtRwRand);

   signal.SetBranchAddress("evtSh1TruePdg",&evtSh1TruePdg);
   signal.SetBranchAddress("evtSh1TrueDang",&evtSh1TrueDang);
   signal.SetBranchAddress("evtSh1TrueEDang",&evtSh1TrueEDang);
   signal.SetBranchAddress("evtSh1Energy",&evtSh1Energy);
   signal.SetBranchAddress("evtTotalRecoGeV",&evtTotalRecoGeV);
   signal.SetBranchAddress("evtSh1Gap",&evtSh1Gap);
   signal.SetBranchAddress("evtSh1IsFid",&evtSh1IsFid);
   signal.SetBranchAddress("evtSh1P4[4]",evtSh1P4);
   signal.SetBranchAddress("evtSh1Start[3]",evtSh1Start);
   signal.SetBranchAddress("evtSh1DedxLLL[20]",evtSh1DedxLLL);
   signal.SetBranchAddress("evtSh1DedxLLT[20]",evtSh1DedxLLT);
   signal.SetBranchAddress("evtSh1NPlane",&evtSh1NPlane);
   signal.SetBranchAddress("evtSh1NMIPPlane",&evtSh1NMIPPlane);
   signal.SetBranchAddress("evtEtot",&evtEtot);
   signal.SetBranchAddress("evtSh1SumPt",&evtSh1SumPt);
   signal.SetBranchAddress("evtSh2Energy",&evtSh2Energy);
   signal.SetBranchAddress("evtPi0Mgg",&evtPi0Mgg);
   signal.SetBranchAddress("evtSh1Pi0Mgg",&evtSh1Pi0Mgg);
   signal.SetBranchAddress("evtSh1VtxGeV",&evtSh1VtxGeV);
   signal.SetBranchAddress("evtSh1CosTheta",&evtSh1CosTheta);
   signal.SetBranchAddress("evtSh1Length",&evtSh1Length);
   signal.SetBranchAddress("evtPi0StartDist",&evtPi0StartDist);
   signal.SetBranchAddress("evtPi0LineDist",&evtPi0LineDist);



   background.SetBranchAddress("evtTrueNuCCNC", &evtTrueNuCCNC);
   background.SetBranchAddress("evtTrueNuMode", &evtTrueNuMode);
   background.SetBranchAddress("evtTrueNuPdg", &evtTrueNuPdg);
   background.SetBranchAddress("evtTrueNuEnergy", &evtTrueNuEnergy);
   background.SetBranchAddress("evtTrueNuP4[4]", evtTrueNuP4);
   background.SetBranchAddress("evtTrueNuVtx[3]",evtTrueNuVtx);

   background.SetBranchAddress("evtRwProb[20]",evtRwProb);
   background.SetBranchAddress("evtRwRand[20]",evtRwRand);

   background.SetBranchAddress("evtSh1TruePdg",&evtSh1TruePdg);
   background.SetBranchAddress("evtSh1TrueDang",&evtSh1TrueDang);
   background.SetBranchAddress("evtSh1TrueEDang",&evtSh1TrueEDang);
   background.SetBranchAddress("evtSh1Energy",&evtSh1Energy);
   background.SetBranchAddress("evtTotalRecoGeV",&evtTotalRecoGeV);
   background.SetBranchAddress("evtSh1Gap",&evtSh1Gap);
   background.SetBranchAddress("evtSh1IsFid",&evtSh1IsFid);
   background.SetBranchAddress("evtSh1P4[4]",evtSh1P4);
   background.SetBranchAddress("evtSh1Start[3]",evtSh1Start);
   background.SetBranchAddress("evtSh1DedxLLL[20]",evtSh1DedxLLL);
   background.SetBranchAddress("evtSh1DedxLLT[20]",evtSh1DedxLLT);
   background.SetBranchAddress("evtSh1NPlane",&evtSh1NPlane);
   background.SetBranchAddress("evtSh1NMIPPlane",&evtSh1NMIPPlane);
   background.SetBranchAddress("evtEtot",&evtEtot);
   background.SetBranchAddress("evtSh1SumPt",&evtSh1SumPt);
   background.SetBranchAddress("evtSh2Energy",&evtSh2Energy);
   background.SetBranchAddress("evtPi0Mgg",&evtPi0Mgg);
   background.SetBranchAddress("evtSh1Pi0Mgg",&evtSh1Pi0Mgg);
   background.SetBranchAddress("evtSh1VtxGeV",&evtSh1VtxGeV);
   background.SetBranchAddress("evtSh1CosTheta",&evtSh1CosTheta);
   background.SetBranchAddress("evtSh1Length",&evtSh1Length);
   background.SetBranchAddress("evtPi0StartDist",&evtPi0StartDist);
   background.SetBranchAddress("evtPi0LineDist",&evtPi0LineDist);


   TTree *simu = new TTree("MonteCarlo", "Filtered Monte Carlo Events");
   double egLLL, egLLT, emuLLL, emuLLT, epi0LLL, epi0LLT, epLLL,epLLT,enLLL,enLLT,epiLLL,epiLLT,gap, pi0mass;
   double vtxgev; 
   double shE; 
   double costheta; 
   double length; 

   simu->Branch("egLLL", &egLLL, "egLLL/D");
   simu->Branch("egLLT", &egLLT, "egLLT/D");
   simu->Branch("emuLLL", &emuLLL, "emuLLL/D");
   simu->Branch("emuLLT", &emuLLT, "emuLLT/D");
   simu->Branch("epi0LLL", &epi0LLL, "epi0LLL/D");
   simu->Branch("epi0LLT", &epi0LLT, "epi0LLT/D");
   simu->Branch("epLLL", &epLLL, "epLLL/D");
   simu->Branch("epLLT", &epLLT, "epLLT/D");
   simu->Branch("enLLL", &enLLL, "enLLL/D");
   simu->Branch("enLLT", &enLLT, "enLLT/D");
   simu->Branch("epiLLL", &epiLLL, "epiLLL/D");
   simu->Branch("epiLLT", &epiLLT, "epiLLT/D");
   simu->Branch("gap",    &gap, "gap/D");
   simu->Branch("pi0mass", &pi0mass, "pi0mass/D");
   simu->Branch("vtxgev", &vtxgev, "vtxgev/D");
   simu->Branch("shE", &shE, "shE/D");
//   simu->Branch("ntrk", &ntrk, "ntrk/I");
   simu->Branch("costheta", &costheta, "costheta/D");
   simu->Branch("length", &length, "length/D");
   simu->Branch("type",   &type,   "type/I");

   TTree *annMC = new TTree("annMC", "Filtered Monte Carlo Events");
   double trueNuE, etot, enue, sh1Energy, ANN, wSig, wBkg;
   double annPi0StartDist, annPi0LineDist;
   annMC->Branch("egLLL", &egLLL, "egLLL/D");
   annMC->Branch("egLLT", &egLLT, "egLLT/D");
   annMC->Branch("emuLLL", &emuLLL, "emuLLL/D");
   annMC->Branch("emuLLT", &emuLLT, "emuLLT/D");
   annMC->Branch("epi0LLL", &epi0LLL, "epi0LLL/D");
   annMC->Branch("epi0LLT", &epi0LLT, "epi0LLT/D");
   annMC->Branch("epLLL", &epLLL, "epLLL/D");
   annMC->Branch("epLLT", &epLLT, "epLLT/D");
   annMC->Branch("enLLL", &enLLL, "enLLL/D");
   annMC->Branch("enLLT", &enLLT, "enLLT/D");
   annMC->Branch("epiLLL", &epiLLL, "epiLLL/D");
   annMC->Branch("epiLLT", &epiLLT, "epiLLT/D");
   annMC->Branch("gap",    &gap, "gap/D");
   annMC->Branch("pi0mass",    &pi0mass, "pi0mass/D");
   annMC->Branch("vtxgev",    &vtxgev, "vtxgev/D");
   annMC->Branch("length",    &length, "length/D");
   annMC->Branch("annPi0StartDist",    &annPi0StartDist, "annPi0StartDist/D");
   annMC->Branch("annPi0LineDist",    &annPi0LineDist, "annPi0LineDist/D");
   annMC->Branch("evtTrueNuCCNC", &evtTrueNuCCNC, "evtTrueNuCCNC/I");
   annMC->Branch("evtTrueNuPdg", &evtTrueNuPdg, "evtTrueNuPdg/I");
   annMC->Branch("evtTrueNuMode", &evtTrueNuMode, "evtTrueNuMode/I");
   annMC->Branch("trueNuE", &trueNuE, "trueNuE/D");
   annMC->Branch("etot", &etot, "etot/D");
   annMC->Branch("enue", &enue, "enue/D");
   annMC->Branch("sh1Energy", &sh1Energy, "sh1Energy/D");
   annMC->Branch("type",   &type,   "type/I");
   annMC->Branch("wSig",   &wSig,   "wSig/D");
   annMC->Branch("wBkg",   &wBkg,   "wBkg/D");
   annMC->Branch("ANN",   &ANN,   "ANN/D");

   int nb0=0,nb1=0,nb2=0,nb3=0;
   int nbNueCC0=0,nbNueCC1=0,nbNueCC2=0,nbNueCC2_a=0,nbNueCC3=0;
   int nbNumuCC0=0,nbNumuCC1=0,nbNumuCC2=0,nbNumuCC3=0;
   int nbNC0=0,nbNC1=0,nbNC2=0,nbNC3=0;

   int ns0=0,ns1=0,ns2=0,ns3=0;
   int normSig = 0, normBkg =0, totBkg=0;
   type = 1;

   for (int i = 0; i < signal.GetEntries(); i++) {
      signal.GetEntry(i);
      if(!(evtTrueNuCCNC==0&&evtTrueNuPdg==12&&(evtRwRand[0]>0&&evtRwRand[0]<evtRwProb[0])))continue;
      if(i%2==1)ns0++;
//      if(evtSh1Energy!=evtSheEnergy)continue;
//      if(fabs(evtSh1TruePdg)!=11)continue;
      if(evtSh1TrueDang>30||fabs(evtSh1TruePdg)!=11)continue;
//      if(!(evtSh1TrueEDang<30&&evtSh1TrueEDang>0))continue;
//      if(!(evtSh1IsFid==1&&evtSh1NPlane>-15&&evtSh1Energy>0.0))continue;
      if(!(evtSh1Energy>0.0))continue;
      if(i%2==1)ns1++;
//      if(evtSh1DedxLLL[0]<0)continue;
      if(evtSh1DedxLLL[0] - evtSh1DedxLLL[2]<-0.2)continue;
//      if(evtPi0Mgg>0.05&&evtPi0Mgg<0.22)continue;
//      if(!(evtSh1Enue/1.40694>1.0&&evtSh1Enue/1.40694<Ehigh))continue;

      if(i%2==1)ns2++;

      if((double)i>(double)signal.GetEntries()*rsig)continue;

      egLLL = evtSh1DedxLLL[0] - evtSh1DedxLLL[1];
      egLLT = evtSh1DedxLLT[0] - evtSh1DedxLLT[1];
      emuLLL = evtSh1DedxLLL[0] - evtSh1DedxLLL[2]; 
      emuLLT = evtSh1DedxLLT[0] - evtSh1DedxLLT[2]; 
      epi0LLL = evtSh1DedxLLL[0] - evtSh1DedxLLL[3];
      epi0LLT = evtSh1DedxLLT[0] - evtSh1DedxLLT[3];
      epLLL = evtSh1DedxLLL[0] - evtSh1DedxLLL[4];
      epLLT = evtSh1DedxLLT[0] - evtSh1DedxLLT[4];
      enLLL = evtSh1DedxLLL[0] - evtSh1DedxLLL[5];
      enLLT = evtSh1DedxLLT[0] - evtSh1DedxLLT[5];
      epiLLL = evtSh1DedxLLL[0] - evtSh1DedxLLL[6];
      epiLLT = evtSh1DedxLLT[0] - evtSh1DedxLLT[6];
      gap = evtSh1Gap; 
      pi0mass = MAX(evtSh1Pi0Mgg,0);
      shE = evtSh1Energy/evtEtot;
//      shE = evtSh1Energy*5.63616e-01/evtSh1SliceGeV;
      vtxgev = evtSh1VtxGeV;
//      costheta = evtSh1SumPt/evtSh1SliceGeV;
      costheta = evtSh1CosTheta; 
      length = evtSh1Length/evtSh1Energy;
      simu->Fill();
      normSig++;
   }

   type = 0;
   for (int i = 0; i < background.GetEntries(); i++) {
//      if(i>36383)continue; 
      background.GetEntry(i);
      if(!((fabs(evtTrueNuPdg)==14&&evtRwRand[2]>0&&evtRwRand[2]<evtRwProb[2])||(fabs(evtTrueNuPdg)==12&&evtRwRand[1]>0&&evtRwRand[1]<evtRwProb[1])))continue;       
      if(i%2==1)nb0++;

      if(!((fabs(evtTrueNuPdg)==14)||(fabs(evtTrueNuPdg)==12)))continue;       
      if(i%2==1&&evtTrueNuCCNC==0&&fabs(evtTrueNuPdg)==14&&evtRwRand[2]>0&&evtRwRand[2]<evtRwProb[2])nbNumuCC0++;
      if(i%2==1&&evtTrueNuCCNC==1&&((fabs(evtTrueNuPdg)==14)||(fabs(evtTrueNuPdg)==12&&evtRwRand[1]>0&&evtRwRand[1]<evtRwProb[1])))nbNC0++;
      if(i%2==1&&evtTrueNuCCNC==0&&fabs(evtTrueNuPdg)==12&&evtRwRand[1]>0&&evtRwRand[1]<evtRwProb[1])nbNueCC0++;

      if(!(evtSh1NPlane>-15&&evtSh1Energy>0.0))continue;
      if(i%2==1)nb1++;

      if(i%2==1&&evtTrueNuCCNC==0&&fabs(evtTrueNuPdg)==14&&evtRwRand[2]>0&&evtRwRand[2]<evtRwProb[2])nbNumuCC1++; 
      if(i%2==1&&evtTrueNuCCNC==1&&((fabs(evtTrueNuPdg)==14&&evtRwRand[2]>0&&evtRwRand[2]<evtRwProb[2])||(fabs(evtTrueNuPdg)==12&&evtRwRand[1]>0&&evtRwRand[1]<evtRwProb[1])))nbNC1++;      
      if(i%2==1&&evtTrueNuCCNC==0&&fabs(evtTrueNuPdg)==12&&evtRwRand[1]>0&&evtRwRand[1]<evtRwProb[1])nbNueCC1++;


      if(evtSh1DedxLLL[0] - evtSh1DedxLLL[2]<-0.2)continue;
//      if(evtPi0Mgg>0.05&&evtPi0Mgg<0.22)continue;
//      if(evtSh1DedxLLL[0]<0)continue;
//      if(!(evtSh1Enue/1.40694>1.0&&evtSh1Enue/1.40694<Ehigh))continue;

      if(i%2==1)nb2++;
      if(i%2==1&&evtTrueNuCCNC==0&&fabs(evtTrueNuPdg)==14&&evtRwRand[2]>0&&evtRwRand[2]<evtRwProb[2])nbNumuCC2++; 
      if(i%2==1&&evtTrueNuCCNC==1&&((fabs(evtTrueNuPdg)==14&&evtRwRand[2]>0&&evtRwRand[2]<evtRwProb[2])||(fabs(evtTrueNuPdg)==12&&evtRwRand[1]>0&&evtRwRand[1]<evtRwProb[1])))nbNC2++;      
      if(i%2==1&&evtTrueNuCCNC==0&&fabs(evtTrueNuPdg)==12&&evtRwRand[1]>0&&evtRwRand[1]<evtRwProb[1])nbNueCC2++;
      if(evtTrueNuCCNC==0&&fabs(evtTrueNuPdg)==12)continue;
//      nb3++;

      if((double)i>(double)background.GetEntries()*rbg)continue;

      egLLL = evtSh1DedxLLL[0] - evtSh1DedxLLL[1];
      egLLT = evtSh1DedxLLT[0] - evtSh1DedxLLT[1];
      emuLLL = evtSh1DedxLLL[0] - evtSh1DedxLLL[2];
      emuLLT = evtSh1DedxLLT[0] - evtSh1DedxLLT[2];
      epi0LLL = evtSh1DedxLLL[0] - evtSh1DedxLLL[3];
      epi0LLT = evtSh1DedxLLT[0] - evtSh1DedxLLT[3];
      epLLL = evtSh1DedxLLL[0] - evtSh1DedxLLL[4];
      epLLT = evtSh1DedxLLT[0] - evtSh1DedxLLT[4];
      enLLL = evtSh1DedxLLL[0] - evtSh1DedxLLL[5];
      enLLT = evtSh1DedxLLT[0] - evtSh1DedxLLT[5];
      epiLLL = evtSh1DedxLLL[0] - evtSh1DedxLLL[6];
      epiLLT = evtSh1DedxLLT[0] - evtSh1DedxLLT[6];
      gap = evtSh1Gap; 
      pi0mass = MAX(evtSh1Pi0Mgg,0);
      vtxgev = evtSh1VtxGeV;
//      costheta = evtSh1SumPt/evtSh1SliceGeV;
      costheta = evtSh1CosTheta; 
      length = evtSh1Length/evtSh1Energy;
      shE = evtSh1Energy/evtEtot;
      simu->Fill();
      normBkg++;
   }

   cout<<"Nsig, Nbig, totBkg, scaleBkg "<<normSig<<" "<<normBkg<<" "<<endl;

   double scalepotsig = 18.0e+20/((ns0/(2.87128765282905034e-02*6938.035))*2.99649003626026520e+21);//2.38399959425089536e+19);//NDOS
   double scalepotNumuCC = 18.0e+20/((nbNumuCC0/(6938.035-199.21-5511.0658))*3.02657807308939830e+21);//2.38399959425089536e+19);//NDOS
   double scalepotNueCC = 18.0e+20/((nbNueCC0/82.02)*3.02657807308939830e+21);//2.38399959425089536e+19);//NDOS
   double scalepotNC = 18.0e+20/((nbNC0/2664.42968)*3.02657807308939830e+21);//2.38399959425089536e+19);//NDOS
   cout<<"nbNumuCC0, scalepotNumuCC "<<nbNumuCC0<<" "<<scalepotNumuCC<<endl;

   // Build and train the NN ptsumf is used as a weight since we are primarly 
   // interested  by high pt events.
   // The datasets used here are the same as the default ones.
/*
   TMultiLayerPerceptron *mlp = 
      new TMultiLayerPerceptron("epi0LLL,epi0LLT,epLLL,epLLT,enLLL,enLLT,epiLLL,epiLLT:15:3:type",
                                simu,"Entry$%2","(Entry$+1)%2");
*/
/*
   TMultiLayerPerceptron *mlp =
      new TMultiLayerPerceptron("@egLLL,@egLLT,@emuLLL,@emuLLT,@epi0LLL,@epi0LLT,@epLLL,@epLLT,@enLLL,@enLLT,@epiLLL,@epiLLT,@pi0mass,@vtxgev,@gap:18:12:6:type",                                simu,"Entry$%2","(Entry$+1)%2");
*/

   TMultiLayerPerceptron *mlp =       
    new TMultiLayerPerceptron("@egLLL,@egLLT,@emuLLL,@emuLLT,@epi0LLL,@epi0LLT,@epLLL,@epLLT,@enLLL,@enLLT,@epiLLL,@epiLLT,@pi0mass,@shE,@vtxgev,@gap,@costheta:22:12:6:type",                                simu,"Entry$%2","(Entry$+1)%2");



/*
   TMultiLayerPerceptron *mlp =
      new TMultiLayerPerceptron("@egLLL,@egLLT,@emuLLL,@emuLLT,@epi0LLL,@epi0LLT,@epLLL,@epLLT,@enLLL,@enLLT,@epiLLL,@epiLLT,@vtxgev,@gap:22:14:8:type",                                simu,"Entry$%2","(Entry$+1)%2");
*/
/*
   TMultiLayerPerceptron *mlp =       
      new TMultiLayerPerceptron("@egLLL,@egLLT,@emuLLL,@emuLLT,@epi0LLL,@epi0LLT,@epLLL,@epLLT,@enLLL,@enLLT,@epiLLL,@epiLLT,@pi0mass,@shE,@gap:18:12:6:type",                                simu,"Entry$%2","(Entry$+1)%2");
*/
   mlp->Train(ntrain, "text,graph,update=10");
   mlp->DumpWeights("weights_shape_fd_elec_140809.txt"); 
   mlp->Export("test","python");
   // Use TMLPAnalyzer to see what it looks for
   TCanvas* mlpa_canvas1 = new TCanvas("mlpa_canvas1","Network analysis 1", 10,10, 1200,600);
   mlpa_canvas1->Divide(2,1);
   TMLPAnalyzer ana(mlp);
   // Initialisation
   ana.GatherInformations();
   // output to the console
   ana.CheckNetwork();
   mlpa_canvas1->cd(1);
   // shows how each variable influences the network
   ana.DrawDInputs();
   mlpa_canvas1->cd(2);
   // shows the network structure
   mlp->Draw();
   mlpa_canvas1->Update();

   TCanvas* mlpa_canvas2 = new TCanvas("mlpa_canvas2","Network analysis 2", 10,10, 1200,600);
   mlpa_canvas2->Divide(2,1);
   mlpa_canvas2->cd(1);
   // draws the resulting network
   ana.DrawNetwork(0,"type==1","type==0");

   mlpa_canvas2->cd(2);
   // Use the NN to plot the results for each sample
   // This will give approx. the same result as DrawNetwork.
   // All entries are used, while DrawNetwork focuses on 
   // the test sample. Also the xaxis range is manually set.
   TH1F *bg = new TH1F("bgh", "NN output", 50, -.5, 1.5);
   TH1F *bgNumuCC = new TH1F("bgNumuCC", "NN output", 50, -.5, 1.5);
   TH1F *bgNC = new TH1F("bgNC", "NN output", 50, -.5, 1.5);
   TH1F *bgNueCC= new TH1F("bgNueCC", "NN output", 50, -.5, 1.5);

   TH1F *sig = new TH1F("sigh", "NN output", 50, -.5, 1.5);
   TH1F *sigbg = new TH1F("sigbgh", "NN output", 50, -.5, 1.5);


//   bg->SetDirectory(0);
//   bgNumuCC->SetDirectory(0);
//   bgNC->SetDirectory(0);
//   bgNueCC->SetDirectory(0);
//   sig->SetDirectory(0);

   Double_t params[17];
   for (int i = 0; i < background.GetEntries(); i++) {
//      if((double)i>(double)background.GetEntries()*rbg)continue;
      if(i%2==0)continue;
//      if(i>36383)continue; 
      background.GetEntry(i);
      if(!((fabs(evtTrueNuPdg)==14&&evtRwRand[2]>0&&evtRwRand[2]<evtRwProb[2])||(fabs(evtTrueNuPdg)==12&&evtRwRand[1]>0&&evtRwRand[1]<evtRwProb[1])))continue; 
      if(!(evtSh1NPlane>-15&&evtSh1Energy>0.0))continue;
      if(evtSh1DedxLLL[0] - evtSh1DedxLLL[2]<-0.2)continue;
//      if(evtPi0Mgg>0.05&&evtPi0Mgg<0.22)continue;
//      if(evtSh1DedxLLL[0]<0)continue;
      //if(!((evtSh1Energy + 0.282525 + 1.0766*(evtEtot-evtSh1Energy))/1.015>Elow&&(evtSh1Energy + 0.282525 + 1.0766*(evtEtot-evtSh1Energy))/1.015<Ehigh))continue;
      if(!(evtSh1NueEnergy>Elow&&evtSh1NueEnergy<Ehigh))continue;
//      if(!(evtSh1Energy>Elow&&evtSh1Energy<Ehigh))continue;
//      if(!(evtSh1Enue/1.40694>1.0&&evtSh1Enue/1.40694<Ehigh))continue;


      params[0] = evtSh1DedxLLL[0] - evtSh1DedxLLL[1];
      params[1] = evtSh1DedxLLT[0] - evtSh1DedxLLT[1];
      params[2] = evtSh1DedxLLL[0] - evtSh1DedxLLL[2];
      params[3] = evtSh1DedxLLT[0] - evtSh1DedxLLT[2];
      params[4] = evtSh1DedxLLL[0] - evtSh1DedxLLL[3];
      params[5] = evtSh1DedxLLT[0] - evtSh1DedxLLT[3];
      params[6] = evtSh1DedxLLL[0] - evtSh1DedxLLL[4];
      params[7] = evtSh1DedxLLT[0] - evtSh1DedxLLT[4];
      params[8] = evtSh1DedxLLL[0] - evtSh1DedxLLL[5];
      params[9] = evtSh1DedxLLT[0] - evtSh1DedxLLT[5];
      params[10] = evtSh1DedxLLL[0] - evtSh1DedxLLL[6];
      params[11] = evtSh1DedxLLT[0] - evtSh1DedxLLT[6];
      params[12] = MAX(evtSh1Pi0Mgg,0);
      params[13] = evtSh1Energy/evtEtot;
      params[14] = evtSh1VtxGeV;
      params[15] = evtSh1Gap;

     params[16] = evtSh1CosTheta; 
//     params[17] = evtSh1SumPt/evtSh1SliceGeV; 
//     params[18] = evtSh1Length/evtSh1Energy;



//      params[8] = sqrt((evtSh1Start[0]-evtTrueNuVtx[0])**2+(evtSh1Start[1]-evtTrueNuVtx[1])**2+(evtSh1Start[2]-evtTrueNuVtx[2])**2); 
//      if(fabs(evtSh1DedxLLL[0] - evtSh1DedxLLL[2])>10)continue;
//      if(fabs(evtSh1DedxLLT[0] - evtSh1DedxLLT[2])>10)continue;
//      if(fabs(evtSh1DedxLLL[0] - evtSh1DedxLLL[3])>10)continue;
//      if(fabs(evtSh1DedxLLT[0] - evtSh1DedxLLT[3])>10)continue;
//      if(fabs(evtSh1DedxLLL[0] - evtSh1DedxLLL[5])>10)continue;
//      if(fabs(evtSh1DedxLLT[0] - evtSh1DedxLLT[5])>10)continue;
//      if(fabs(evtSh1DedxLLL[0] - evtSh1DedxLLL[6])>10)continue;
//      if(fabs(evtSh1DedxLLT[0] - evtSh1DedxLLT[6])>10)continue;
//      if(fabs(evtSh1DedxLLL[0] - evtSh1DedxLLL[7])>10)continue;
//      if(fabs(evtSh1DedxLLT[0] - evtSh1DedxLLT[7])>10)continue;
//      bg->Fill(mlp->Evaluate(0, params));
      if(evtTrueNuCCNC==0&&fabs(evtTrueNuPdg)==14&&evtRwRand[2]>0&&evtRwRand[2]<evtRwProb[2]){
        bgNumuCC->Fill(mlp->Evaluate(0, params), scalepotNumuCC);
        bg->Fill(mlp->Evaluate(0, params), scalepotNumuCC);
      }
      if(evtTrueNuCCNC==1&&((fabs(evtTrueNuPdg)==14&&evtRwRand[2]>0&&evtRwRand[2]<evtRwProb[2])||(fabs(evtTrueNuPdg)==12&&evtRwRand[1]>0&&evtRwRand[1]<evtRwProb[1]))){
        bgNC->Fill(mlp->Evaluate(0, params), scalepotNC);
        bg->Fill(mlp->Evaluate(0, params), scalepotNC);
      }
      if(evtTrueNuCCNC==0&&fabs(evtTrueNuPdg)==12&&evtRwRand[1]>0&&evtRwRand[1]<evtRwProb[1]){
        bgNueCC->Fill(mlp->Evaluate(0, params), scalepotNueCC);
        bg->Fill(mlp->Evaluate(0, params), scalepotNueCC);
      }
   }

   for (int i = 0; i < signal.GetEntries(); i++) {
//      if((double)i>(double)signal.GetEntries()*rsig)continue;
      if(i%2==0)continue;
      signal.GetEntry(i);
      if(!(evtTrueNuCCNC==0&&evtTrueNuPdg==12&&(evtRwRand[0]>0&&evtRwRand[0]<evtRwProb[0])))continue;
//      if(evtSh1TrueDang>10||fabs(evtSh1TruePdg)!=11)continue;
      if(!(evtSh1NPlane>-15&&evtSh1Energy>0.0))continue; 

      
      if(evtSh1DedxLLL[0] - evtSh1DedxLLL[2]<-0.2)continue;
//      if(evtPi0Mgg>0.05&&evtPi0Mgg<0.22)continue;
//      if(evtSh1DedxLLL[0]<0)continue;
      //if(!((evtSh1Energy + 0.282525 + 1.0766*(evtEtot-evtSh1Energy))/1.015>Elow&&(evtSh1Energy + 0.282525 + 1.0766*(evtEtot-evtSh1Energy))/1.015<Ehigh))continue;
      if(!(evtSh1NueEnergy>Elow&&evtSh1NueEnergy<Ehigh))continue;
//      if(!(evtSh1Energy>Elow&&evtSh1Energy<Ehigh))continue;
//      if(!(evtSh1Enue/1.40694>1.0&&evtSh1Enue/1.40694<Ehigh))continue;


      params[0] = evtSh1DedxLLL[0] - evtSh1DedxLLL[1];
      params[1] = evtSh1DedxLLT[0] - evtSh1DedxLLT[1];      
      params[2] = evtSh1DedxLLL[0] - evtSh1DedxLLL[2];
      params[3] = evtSh1DedxLLT[0] - evtSh1DedxLLT[2];
      params[4] = evtSh1DedxLLL[0] - evtSh1DedxLLL[3];
      params[5] = evtSh1DedxLLT[0] - evtSh1DedxLLT[3];
      params[6] = evtSh1DedxLLL[0] - evtSh1DedxLLL[4];
      params[7] = evtSh1DedxLLT[0] - evtSh1DedxLLT[4];
      params[8] = evtSh1DedxLLL[0] - evtSh1DedxLLL[5];
      params[9] = evtSh1DedxLLT[0] - evtSh1DedxLLT[5];
      params[10] = evtSh1DedxLLL[0] - evtSh1DedxLLL[6];
      params[11] = evtSh1DedxLLT[0] - evtSh1DedxLLT[6];
      params[12] = MAX(evtSh1Pi0Mgg,0);
      params[13] = evtSh1Energy/evtEtot;
      params[14] = evtSh1VtxGeV;
      params[15] = evtSh1Gap;
     params[16] = evtSh1CosTheta; 
//     params[17] = evtSh1SumPt/evtSh1SliceGeV; 
//     params[18] = evtSh1Length/evtSh1Energy;


//      params[8] = sqrt((evtSh1Start[0]-evtTrueNuVtx[0])**2+(evtSh1Start[1]-evtTrueNuVtx[1])**2+(evtSh1Start[2]-evtTrueNuVtx[2])**2);

//      if(fabs( evtSh1DedxLLL[0] - evtSh1DedxLLL[2])>10)continue;
//      if(fabs( evtSh1DedxLLT[0] - evtSh1DedxLLT[2])>10)continue;
//      if(fabs( evtSh1DedxLLL[0] - evtSh1DedxLLL[3])>10)continue;
//      if(fabs( evtSh1DedxLLT[0] - evtSh1DedxLLT[3])>10)continue;
//      if(fabs(evtSh1DedxLLL[0] - evtSh1DedxLLL[5])>10)continue;
//      if(fabs(evtSh1DedxLLT[0] - evtSh1DedxLLT[5])>10)continue;
//      if(fabs(evtSh1DedxLLL[0] - evtSh1DedxLLL[6])>10)continue;
//      if(fabs(evtSh1DedxLLT[0] - evtSh1DedxLLT[6])>10)continue;
//      if(fabs( evtSh1DedxLLL[0] - evtSh1DedxLLL[7])>10)continue;
//      if(fabs( evtSh1DedxLLT[0] - evtSh1DedxLLT[7])>10)continue;
//      cout<<"sig eval "<<mlp->Evaluate(0,params)<<endl;
      sig->Fill(mlp->Evaluate(0,params),scalepotsig);
      if(fabs(evtSh1TruePdg)!=11)sigbg->Fill(mlp->Evaluate(0,params),scalepotsig);
   }

//   TH1F *bg = new TH1F("bgh", "NN output", 50, -.5, 1.5);
//   TH1F *sig = new TH1F("sigh", "NN output", 50, -.5, 1.5);
   TH1F *hfom = new TH1F("hfom", "NN output", 50, -.5, 1.5);
   TH1F *heff = new TH1F("heff", "NN output", 50, -.5, 1.5);
   TH1F *hbgeff = new TH1F("hbgeff", "NN output", 50, -.5, 1.5);
   TH1F *hbgNumuCCeff = new TH1F("hbgNumuCCeff", "NN output", 50, -.5, 1.5);
   TH1F *hbgNCeff = new TH1F("hbgNCeff", "NN output", 50, -.5, 1.5);
   TH1F *hbgNueCCeff = new TH1F("hbgNueCCeff", "NN output", 50, -.5, 1.5);
   for(int i=0;i<50;i++){
     double sumnbg = bg->Integral(i+1, 50);
     double sumnbgNueCC = bgNueCC->Integral(i+1, 50);
     double sumnsig = sig->Integral(i+1, 50);
     double eff = double(sig->Integral(i+1, 50))/double(sig->Integral(1, 50));
     double bgeff = double(bg->Integral(i+1, 50))/double(bg->Integral(1, 50));
     double bgNumuCCeff = double(bgNumuCC->Integral(i+1, 50))/double(bgNumuCC->Integral(1, 50));
     double bgNCeff = double(bgNC->Integral(i+1, 50))/double(bgNC->Integral(1, 50));
     double bgNueCCeff = double(bgNueCC->Integral(i+1, 50))/double(bgNueCC->Integral(1, 50));
     heff->SetBinContent(i+1,eff);
     hbgeff->SetBinContent(i+1,bgeff);
     hbgNumuCCeff->SetBinContent(i+1,bgNumuCCeff);
     hbgNCeff->SetBinContent(i+1,bgNCeff);
     hbgNueCCeff->SetBinContent(i+1,bgNueCCeff);
     if(sumnsig+sumnbg-sumnbgNueCC<0.000001){
       hfom->SetBinContent(i+1,0);
       continue;
     }
     double significance = 0;
     if(sumnsig+sumnbg-sumnbgNueCC>0) significance = double(sumnsig)/sqrt(sumnsig+sumnbg-sumnbgNueCC); 
//     if(sumnbg>0)significance = double(sumnsig)/sqrt(sumnbg); 
     cout<<"FOM, sig, bkg  "<<significance<<" "<<sumnsig<<" "<<sumnbg<<" "<<endl;
     hfom->SetBinContent(i+1,significance);
   }

   bg->SetLineColor(kBlue);
//   bg->SetFillStyle(3008);   
//   bg->SetFillColor(kBlue);
   sig->SetLineColor(kRed);
   sig->SetFillStyle(3003); 
   sig->SetFillColor(kRed);
//   bg->SetStats(0);
//   sig->SetStats(0);
   bg->Draw();
   sig->Draw("same");
   sigbg->Draw("same");
//   sig->DrawNormalized("same", sig->GetEntries()*scalesig);
   TLegend *legend = new TLegend(.75, .80, .95, .95);
   legend->AddEntry(bg, "Background (nhc)");
   legend->AddEntry(sig, "Signal (Nue_CCQE)");
   legend->Draw();
   mlpa_canvas2->cd(0);
   mlpa_canvas2->Update();

   cout<<"scalepotsig "<<scalepotsig<<endl;
   cout<<"scalepotNumuCC "<<scalepotNumuCC<<endl;
   cout<<"scalepotNC "<<scalepotNC<<endl;
   cout<<"scalepotNueCC "<<scalepotNueCC<<endl;

   TCanvas* mlpa_canvas3 = new TCanvas("mlpa_canvas3","Network analysis 3", 10,10, 800,400);
   mlpa_canvas3->Divide(2,1);
   mlpa_canvas3->cd(1);
   hfom->GetYaxis()->SetTitle("FOM");
   hfom->GetXaxis()->SetTitle("ANN");
   hfom->GetXaxis()->SetRangeUser(0.4,1.2);
   hfom->Draw("l");
   line1 = new TLine(hfom->GetBinCenter(hfom->GetMaximumBin()),0,hfom->GetBinCenter(hfom->GetMaximumBin()),hfom->GetMaximum());
   line1->SetLineWidth(4);
   line1->SetLineColor(kRed);
   line1->Draw("same");

   mlpa_canvas3->Update();

   mlpa_canvas3->cd(2);
   heff->GetYaxis()->SetTitle("PID Eff.");
   heff->GetXaxis()->SetTitle("ANN");
   heff->GetYaxis()->SetRangeUser(0,1);
   heff->GetXaxis()->SetRangeUser(0.4,1.2);
   heff->Draw("l");
   line2 = new TLine(hfom->GetBinCenter(hfom->GetMaximumBin()),0,hfom->GetBinCenter(hfom->GetMaximumBin()),1.0);
   line2->SetLineWidth(4);
   line2->SetLineColor(kRed);
   line2->Draw("same");

   mlpa_canvas3->Update();

   TCanvas* mlpa_canvas4 = new TCanvas("mlpa_canvas4","Network analysis 4", 10,10, 600,400);
   mlpa_canvas4->Divide(1,1);
   mlpa_canvas4->cd(1);
   bg->GetYaxis()->SetTitle("Events");
   bg->GetXaxis()->SetTitle("ANN");
   bg->SetLineColor(kBlue);
   bgNumuCC->SetLineColor(9);
   bgNC->SetLineColor(7);
   bgNueCC->SetLineColor(6);
   sig->SetLineColor(kRed);
   sig->SetFillStyle(3003); 
   sig->SetFillColor(kRed);
//   bg->SetStats(0);
//   sig->SetStats(0);

   bg->Draw();
   bgNumuCC->Draw("same");
   bgNC->Draw("same");
   bgNueCC->Draw("same");
   sig->Draw("same");
//   sig->DrawNormalized("same", sig->GetEntries()*scalesig);
   TLegend *legend = new TLegend(.75, .80, .95, .95);
   legend->AddEntry(bg, "Background (nhc)");
   legend->AddEntry(bgNumuCC, "Beam #nu_{#mu} CC");
   legend->AddEntry(bgNC, "Beam NC");
   legend->AddEntry(bgNueCC, "Beam #nu_{e} CC");
   legend->AddEntry(sig, "Signal #nu_{e} CC");
   legend->Draw();
   mlpa_canvas4->Update();



   type = 1;   
   for (int i = 0; i < signal.GetEntries(); i++) {
//      if((double)i>(double)signal.GetEntries()*rsig)continue;
      if(i%2==0)continue;
      signal.GetEntry(i);
      if(!(evtTrueNuCCNC==0&&evtTrueNuPdg==12&&(evtRwRand[0]>0&&evtRwRand[0]<evtRwProb[0])))continue;
//      if(evtSh1TrueDang>10||fabs(evtSh1TruePdg)!=11)continue;
//      if(!(evtSh1IsFid==1&&evtSh1NPlane>-15&&evtSh1Energy>0.0))continue;
      if(!(evtSh1Energy>0.0))continue;
      if(evtSh1DedxLLL[0] - evtSh1DedxLLL[2]<-0.2)continue;
//      if(evtPi0Mgg>0.05&&evtPi0Mgg<0.22)continue;
      //if(!((evtSh1Energy+0.282525 + 1.0766*(evtEtot-evtSh1Energy))/1.015>Elow&&(evtSh1Energy + 0.282525 + 1.0766*(evtEtot-evtSh1Energy))/1.015<Ehigh))continue;
      if(!(evtSh1NueEnergy>Elow&&evtSh1NueEnergy<Ehigh))continue;
//      if(evtSh1DedxLLL[0]<0)continue;
      egLLL = evtSh1DedxLLL[0] - evtSh1DedxLLL[1];
      egLLT = evtSh1DedxLLT[0] - evtSh1DedxLLT[1];
      emuLLL = evtSh1DedxLLL[0] - evtSh1DedxLLL[2]; 
      emuLLT = evtSh1DedxLLT[0] - evtSh1DedxLLT[2]; 
      epi0LLL = evtSh1DedxLLL[0] - evtSh1DedxLLL[3];
      epi0LLT = evtSh1DedxLLT[0] - evtSh1DedxLLT[3];
      epLLL = evtSh1DedxLLL[0] - evtSh1DedxLLL[4];
      epLLT = evtSh1DedxLLT[0] - evtSh1DedxLLT[4];
      enLLL = evtSh1DedxLLL[0] - evtSh1DedxLLL[5];
      enLLT = evtSh1DedxLLT[0] - evtSh1DedxLLT[5];
      epiLLL = evtSh1DedxLLL[0] - evtSh1DedxLLL[6];
      epiLLT = evtSh1DedxLLT[0] - evtSh1DedxLLT[6];
      gap = evtSh1Gap; 
//    costheta = evtSh1SumPt/evtSh1SliceGeV;
      costheta = evtSh1CosTheta; 
      length = evtSh1Length/evtSh1Energy;
      shE = evtSh1Energy/evtEtot;
      pi0mass = MAX(evtSh1Pi0Mgg,0); 
      annPi0LineDist = evtPi0LineDist;
      annPi0StartDist = evtPi0StartDist;

      params[0] = evtSh1DedxLLL[0] - evtSh1DedxLLL[1];
      params[1] = evtSh1DedxLLT[0] - evtSh1DedxLLT[1];
      params[2] = evtSh1DedxLLL[0] - evtSh1DedxLLL[2];
      params[3] = evtSh1DedxLLT[0] - evtSh1DedxLLT[2];
      params[4] = evtSh1DedxLLL[0] - evtSh1DedxLLL[3];
      params[5] = evtSh1DedxLLT[0] - evtSh1DedxLLT[3];
      params[6] = evtSh1DedxLLL[0] - evtSh1DedxLLL[4];
      params[7] = evtSh1DedxLLT[0] - evtSh1DedxLLT[4];
      params[8] = evtSh1DedxLLL[0] - evtSh1DedxLLL[5];
      params[9] = evtSh1DedxLLT[0] - evtSh1DedxLLT[5];
      params[10] = evtSh1DedxLLL[0] - evtSh1DedxLLL[6];
      params[11] = evtSh1DedxLLT[0] - evtSh1DedxLLT[6];
      params[12] = MAX(evtSh1Pi0Mgg,0);
      params[13] = evtSh1Energy/evtEtot;
      params[14] = evtSh1VtxGeV; 
      params[15] = evtSh1Gap; 
      params[16] = evtSh1CosTheta; 
//    params[17] = evtSh1SumPt/evtSh1SliceGeV; 
//      params[18] = evtSh1Length/evtSh1Energy;


//      params[8] = sqrt((evtSh1Start[0]-evtTrueNuVtx[0])**2+(evtSh1Start[1]-evtTrueNuVtx[1])**2+(evtSh1Start[2]-evtTrueNuVtx[2])**2);
      trueNuE = evtTrueNuEnergy;
      etot = evtEtot;
      //enue = evtSh1Enue;
      sh1Energy = evtSh1Energy;
      ANN = mlp->Evaluate(0,params);
      wSig = scalepotsig;
      wBkg = 0;
      annMC->Fill();
      if(ANN<hfom->GetBinCenter(hfom->GetMaximumBin()))continue;
      //if(!((evtSh1Energy + 0.282525 + 1.0766*(evtEtot-evtSh1Energy))/1.015>Elow&&(evtSh1Energy + 0.282525 + 1.0766*(evtEtot-evtSh1Energy))/1.015<Ehigh))continue;
//      if(!(evtSh1Energy>Elow&&evtSh1Energy<Ehigh))continue;
//      if(!(evtSh1Enue/1.40694>1.0&&evtSh1Enue/1.40694<Ehigh))continue;

      ns3++;
   }

   type = 0;   
   for (int i = 0; i < background.GetEntries(); i++) {
//      if((double)i>(double)background.GetEntries()*rbg)continue;
      if(i%2==0)continue;
//      if(i>36383)continue; 
      background.GetEntry(i);
      if(!((fabs(evtTrueNuPdg)==14&&evtRwRand[2]>0&&evtRwRand[2]<evtRwProb[2])||(fabs(evtTrueNuPdg)==12&&evtRwRand[1]>0&&evtRwRand[1]<evtRwProb[1])))continue; 
//      if(!(evtSh1IsFid==1&&evtSh1NPlane>-15&&evtSh1Energy>0.0))continue;
      if(!(evtSh1Energy>0.0))continue;
      if(evtSh1DedxLLL[0] - evtSh1DedxLLL[2]<-0.2)continue;
//      if(evtPi0Mgg>0.05&&evtPi0Mgg<0.22)continue;
      //if(!((evtSh1Energy+0.282525 + 1.0766*(evtEtot-evtSh1Energy))/1.015>Elow&&(evtSh1Energy + 0.282525 + 1.0766*(evtEtot-evtSh1Energy))/1.015<Ehigh))continue;
      if(!(evtSh1NueEnergy>Elow&&evtSh1NueEnergy<Ehigh))continue;
//      if(evtSh1DedxLLL[0]<0)continue;
      egLLL = evtSh1DedxLLL[0] - evtSh1DedxLLL[1];
      egLLT = evtSh1DedxLLT[0] - evtSh1DedxLLT[1];
      emuLLL = evtSh1DedxLLL[0] - evtSh1DedxLLL[2]; 
      emuLLT = evtSh1DedxLLT[0] - evtSh1DedxLLT[2]; 
      epi0LLL = evtSh1DedxLLL[0] - evtSh1DedxLLL[3];
      epi0LLT = evtSh1DedxLLT[0] - evtSh1DedxLLT[3];
      epLLL = evtSh1DedxLLL[0] - evtSh1DedxLLL[4];
      epLLT = evtSh1DedxLLT[0] - evtSh1DedxLLT[4];
      enLLL = evtSh1DedxLLL[0] - evtSh1DedxLLL[5];
      enLLT = evtSh1DedxLLT[0] - evtSh1DedxLLT[5];
      epiLLL = evtSh1DedxLLL[0] - evtSh1DedxLLL[6];
      epiLLT = evtSh1DedxLLT[0] - evtSh1DedxLLT[6];
      gap = evtSh1Gap;
//      costheta = evtSh1SumPt/evtSh1SliceGeV;
      costheta = evtSh1CosTheta; 
      length = evtSh1Length/evtSh1Energy;
      shE = evtSh1Energy/evtEtot;
      pi0mass = MAX(evtSh1Pi0Mgg,0); 
      annPi0LineDist = evtPi0LineDist;      
      annPi0StartDist = evtPi0StartDist;



      params[0] = evtSh1DedxLLL[0] - evtSh1DedxLLL[1];
      params[1] = evtSh1DedxLLT[0] - evtSh1DedxLLT[1];      
      params[2] = evtSh1DedxLLL[0] - evtSh1DedxLLL[2];
      params[3] = evtSh1DedxLLT[0] - evtSh1DedxLLT[2];
      params[4] = evtSh1DedxLLL[0] - evtSh1DedxLLL[3];
      params[5] = evtSh1DedxLLT[0] - evtSh1DedxLLT[3];
      params[6] = evtSh1DedxLLL[0] - evtSh1DedxLLL[4];
      params[7] = evtSh1DedxLLT[0] - evtSh1DedxLLT[4];
      params[8] = evtSh1DedxLLL[0] - evtSh1DedxLLL[5];
      params[9] = evtSh1DedxLLT[0] - evtSh1DedxLLT[5];
      params[10] = evtSh1DedxLLL[0] - evtSh1DedxLLL[6];
      params[11] = evtSh1DedxLLT[0] - evtSh1DedxLLT[6];
      params[12] = MAX(evtSh1Pi0Mgg,0);
      params[13] = evtSh1Energy/evtEtot;
      params[14] = evtSh1VtxGeV;
      params[15] = evtSh1Gap;
     params[16] = evtSh1CosTheta; 
//     params[17] = evtSh1SumPt/evtSh1SliceGeV; 
//     params[18] = evtSh1Length/evtSh1Energy;


//      params[8] = sqrt((evtSh1Start[0]-evtTrueNuVtx[0])**2+(evtSh1Start[1]-evtTrueNuVtx[1])**2+(evtSh1Start[2]-evtTrueNuVtx[2])**2);
      trueNuE = evtTrueNuEnergy;
      etot = evtEtot;
      //enue = evtSh1Enue;
      sh1Energy = evtSh1Energy;
      ANN = mlp->Evaluate(0,params);
      wSig = 0;
      wBkg = 0;
      if(evtTrueNuCCNC==0&&fabs(evtTrueNuPdg)==14&&evtRwRand[2]>0&&evtRwRand[2]<evtRwProb[2])wBkg=scalepotNumuCC;
      if(evtTrueNuCCNC==1&&((fabs(evtTrueNuPdg)==14&&evtRwRand[2]>0&&evtRwRand[2]<evtRwProb[2])||(fabs(evtTrueNuPdg)==12&&evtRwRand[1]>0&&evtRwRand[1]<evtRwProb[1])))wBkg=scalepotNC;
      if(evtTrueNuCCNC==0&&fabs(evtTrueNuPdg)==12&&evtRwRand[1]>0&&evtRwRand[1]<evtRwProb[1])wBkg=scalepotNueCC;
      annMC->Fill();
//      if(evtTrueNuCCNC==0&&fabs(evtTrueNuPdg)==12)nbNueCC2_a++;
      if(ANN<hfom->GetBinCenter(hfom->GetMaximumBin()))continue;
      //if(!((evtSh1Energy+0.282525 + 1.0766*(evtEtot-evtSh1Energy))/1.015>Elow&&(evtSh1Energy+0.282525+1.0766*(evtEtot-evtSh1Energy))/1.015<Ehigh))continue;
//      if(!(evtSh1Energy>Elow&&evtSh1Energy<Ehigh))continue;
//      if(!(evtSh1Enue/1.40694>1.0&&evtSh1Enue/1.40694<Ehigh))continue;
      nb3++;
      if(evtTrueNuCCNC==0&&fabs(evtTrueNuPdg)==14&&evtRwRand[2]>0&&evtRwRand[2]<evtRwProb[2])nbNumuCC3++;
      if(evtTrueNuCCNC==1&&((fabs(evtTrueNuPdg)==14&&evtRwRand[2]>0&&evtRwRand[2]<evtRwProb[2])||(fabs(evtTrueNuPdg)==12&&evtRwRand[1]>0&&evtRwRand[1]<evtRwProb[1])))nbNC3++;
      if(evtTrueNuCCNC==0&&fabs(evtTrueNuPdg)==12&&evtRwRand[1]>0&&evtRwRand[1]<evtRwProb[1])nbNueCC3++;
   }
   cout<<"nb3 "<<nb3<<endl;
   cout<<"nbNumuCC3 "<<nbNumuCC3<<endl;
   cout<<"nbNC3 "<<nbNC3<<endl;
   cout<<"nbNueCC3 "<<nbNueCC3<<endl;

   TFile f("ann.root","recreate");
   annMC->Write("annMC");
   f.Close();

   std::cout<<"ns0,ns1,ns2,ns3,scalepotsig "<<ns0<<" "<<ns1<<" "<<ns2<<" "<<ns3<<" "<<scalepotsig<<endl;
   double Dns0 = double(ns0*scalepotsig);
   double Dns1 = double(ns1*scalepotsig);
   double Dns2 = double(ns2*scalepotsig);
   double Dns3 = double(ns3*scalepotsig);

   double DnbNumuCC0 = double(nbNumuCC0*scalepotNumuCC);
   double DnbNumuCC1 = double(nbNumuCC1*scalepotNumuCC);
   double DnbNumuCC2 = double(nbNumuCC2*scalepotNumuCC);
   double DnbNumuCC3 = double(nbNumuCC3*scalepotNumuCC);

   double DnbNC0 = double(nbNC0*scalepotNC);
   double DnbNC1 = double(nbNC1*scalepotNC);
   double DnbNC2 = double(nbNC2*scalepotNC);
   double DnbNC3 = double(nbNC3*scalepotNC);

   double DnbNueCC0 = double(nbNueCC0*scalepotNueCC);
   double DnbNueCC1 = double(nbNueCC1*scalepotNueCC);
   double DnbNueCC2 = double(nbNueCC2*scalepotNueCC);
   double DnbNueCC3 = double(nbNueCC3*scalepotNueCC);

   double Dnb0 = double(DnbNumuCC0+DnbNC0+DnbNueCC0);
   double Dnb1 = double(DnbNumuCC1+DnbNC1+DnbNueCC1);
   double Dnb2 = double(DnbNumuCC2+DnbNC2+DnbNueCC2);
   double Dnb3 = double(DnbNumuCC3+DnbNC3+DnbNueCC3);

//   double scalepot = 18.0e+20/((nbNumuCC0/7175.2)*2.8123e+21);//2.38399959425089536e+19);//NDOS


   cout<<"Scaled sig "<<Dns0<<" "<<Dns1<<" "<<Dns2<<" "<<Dns3<<endl;
   cout<<"Scaled bg       "<<Dnb0<<" "<<Dnb1<<" "<<Dnb2<<" "<<Dnb3<<endl;
   cout<<"Scaled bg NumuCC"<<DnbNumuCC0<<" "<<DnbNumuCC1<<" "<<DnbNumuCC2<<" "<<DnbNumuCC3<<endl;
   cout<<"Scaled bg NC    "<<DnbNC0<<" "<<DnbNC1<<" "<<DnbNC2<<" "<<DnbNC3<<endl;
   cout<<"Scaled bg NueCC "<<DnbNueCC0<<" "<<DnbNueCC1<<" "<<DnbNueCC2<<" "<<DnbNueCC3<<endl;
 
   cout<<"ANN  =      "<<hfom->GetBinCenter(hfom->GetMaximumBin())<<endl;
   cout<<"FOM  hist =      "<<hfom->GetBinContent(hfom->GetMaximumBin())<<endl;
   cout<<"FOM       =      "<<double(Dns3)/sqrt(Dns3+Dnb3)<<endl;
   cout<<"Eff. =      "<<double(Dns3)/double(Dns0)<<endl;
   cout<<"ns2 "<<ns2<<endl;
   cout<<"nb2, nb3 "<<nb2<<" "<<nb3<<endl;

/*
   cout<<"BG Eff       . =   "<<hbgeff->GetBinContent(hfom->GetMaximumBin())<<endl;
   cout<<"BG NumuCC Eff. =   "<<hbgNumuCCeff->GetBinContent(hfom->GetMaximumBin())<<endl;
   cout<<"BG NC     Eff. =   "<<hbgNCeff->GetBinContent(hfom->GetMaximumBin())<<endl;
   cout<<"BG NueCC  Eff. =   "<<hbgNueCCeff->GetBinContent(hfom->GetMaximumBin())<<endl;
*/
   cout<<"BG Eff       . =   "<<double(Dnb3)/double(Dnb0)<<endl;
   cout<<"BG NumuCC Eff. =   "<<double(DnbNumuCC3)/double(DnbNumuCC0)<<endl;
   cout<<"BG NC     Eff. =   "<<double(DnbNC3)/double(DnbNC0)<<endl;
   cout<<"BG NueCC  Eff. =   "<<double(DnbNueCC3)/double(DnbNueCC0)<<endl;
}

double MAX(double a, double b){
 if(a>b){	
   return a;	
 }	
 else{	
   return b;	
 }	
}
