////////////////////////////////////////////////////////////////////////
// \file    SREnergy.h
// \brief   This is a simple class for energy estimators in the standard record.  
// \version $Id: SREnergy.cxx,v 1.3 2012-11-19 17:32:22 rocco Exp $  
// \author  $Author: rocco $
// \date    $Date: 2012-11-19 17:32:22 $
////////////////////////////////////////////////////////////////////////
#include<limits>

#include "StandardRecord/SREnergy.h"

namespace caf 
{
  
  SREnergy::SREnergy():
  E(std::numeric_limits<float>::signaling_NaN())
  {  }
  
  
  SREnergy::~SREnergy(){  }
  
  void SREnergy::setDefault()
  {
    E = -5;
  }
  
} // end namespace caf
////////////////////////////////////////////////////////////////////////
