////////////////////////////////////////////////////////////////////////
// \file    SREnergy.h
// \brief   This is a simple class for energy estimators in the standard record.  
// \version $Id: SREnergy.h,v 1.3 2012-11-19 17:32:22 rocco Exp $  
// \author  $Author: rocco $
// \date    $Date: 2012-11-19 17:32:22 $
////////////////////////////////////////////////////////////////////////
#ifndef SRENERGY_H
#define SRENERGY_H

namespace caf
{
  /// This is a simple class for energy estimators in the standard record.  
  /// More complicated energy estimators will have extra fields for other output. 
  class SREnergy
    {
    public:
      ///  Default constructor. 
      SREnergy();
      
      /// Default destuctor.
      virtual ~SREnergy();

      float      E;    ///< Energy      [GeV]

      virtual void setDefault();
    };
  
} // end namespace

#endif // SRENERGY_H
//////////////////////////////////////////////////////////////////////////////
