////////////////////////////////////////////////////////////////////////
// \file    SRTrueParticle.cxx
// \brief   An  SRTrueParticle represents a daughter particle.
// \version $Id: SRTrueParticle.cxx,v 1.3 2012-11-19 17:32:22 rocco Exp $  
// \author  $Author: rocco $
// \date    $Date: 2012-11-19 17:32:22 $
////////////////////////////////////////////////////////////////////////


#include "StandardRecord/SRTrueParticle.h"




namespace caf 
{
  
  SRTrueParticle::SRTrueParticle():
  pdg(std::numeric_limits<int>::signaling_NaN()),
  visE(std::numeric_limits<float>::signaling_NaN()),
  visEinslc(std::numeric_limits<float>::signaling_NaN()),
  p(std::numeric_limits<int>::signaling_NaN(),
    std::numeric_limits<int>::signaling_NaN(),
    std::numeric_limits<int>::signaling_NaN(),
    std::numeric_limits<int>::signaling_NaN())
  {  }
  
  SRTrueParticle::~SRTrueParticle(){  }
  
} // end namespace caf
////////////////////////////////////////////////////////////////////////
