////////////////////////////////////////////////////////////////////////
// \file    SRVertex.cxx
// \brief   An  SRVertex is a collection of tracks and showers.
// \version $Id: SRVertex.cxx,v 1.3 2012-11-19 17:32:23 rocco Exp $  
// \author  $Author: rocco $
// \date    $Date: 2012-11-19 17:32:23 $
////////////////////////////////////////////////////////////////////////

#include "StandardRecord/SRVertex.h"




namespace caf 
{
  
  SRVertex::SRVertex():
  time(std::numeric_limits<float>::signaling_NaN()),
  vtx(std::numeric_limits<float>::signaling_NaN(),
      std::numeric_limits<float>::signaling_NaN(),
      std::numeric_limits<float>::signaling_NaN())
  {  }
  
  
  SRVertex::~SRVertex(){  }
 
  void SRVertex::setDefault(){ 
    time = -5;
    vtx.SetXYZ(0,0,0);
  }
  
} // end namespace caf
////////////////////////////////////////////////////////////////////////
