////////////////////////////////////////////////////////////////////////
// \file    SRVertexBranch.cxx
// \brief   An SRVertexBranch contains vectors of SRVertex.  
//          It is intended for use in the Common Analysis ROOT trees.
//
// \version $Id: SRVertexBranch.cxx,v 1.4 2012-11-19 17:32:23 rocco Exp $
// \author  $Author: rocco $
// \date    $Date: 2012-11-19 17:32:23 $
////////////////////////////////////////////////////////////////////////

#include "StandardRecord/SRVertexBranch.h"


namespace caf 
{
  
  SRVertexBranch::SRVertexBranch():
  elastic()
  {  }
  
  SRVertexBranch::~SRVertexBranch(){  }
 
  void SRVertexBranch::fillSizes(){  
    nelastic = elastic.size();
    nhough = hough.size();

    for(size_t i = 0; i < nelastic; ++i) elastic[i].fillSizes();
  }
  
  
  
} // end namespace caf
////////////////////////////////////////////////////////////////////////
