////////////////////////////////////////////////////////////////////////
/// \brief   Definition of object to store subrun related information
/// \author  brebel@fnal.gov
/// \date
////////////////////////////////////////////////////////////////////////
#include "SummaryData/SubRunData.h"
#include "NovaDAQConventions/DAQConventions.h"

namespace sumdata
{
  //---------------------------------------------------------
  SubRunData::SubRunData() 
    : fDetId(novadaq::cnv::kNDOS)
  {
  }
  
  //---------------------------------------------------------
  SubRunData::SubRunData(int detid)
    : fDetId(detid)
  {
  }
  
  //---------------------------------------------------------
  SubRunData::~SubRunData()
  {
  }
  
} // end namespace sumdata
////////////////////////////////////////////////////////////////////////////  
