#!/bin/bash
g4_file=$1
log_file=$2

path=`dirname $g4_file`
if [ "$path" != "." ]; then
    cp $g4_file ./
    g4_file=`basename $g4_file`
fi


export SECONDARY_DATASET='g4_secondaries_FA14-10-03_nd_genie_fhc_nonswap_geantonly' #As of 2/24/15 this is the default rock secondaries.  If this isn't the desired secondary dataset set something else
export NUMBER_OF_SECONDARY=50 #The default for this is 50, in produciton.  For testing purposes it can probably be less
export OVERLAY_FCL='prodNDRockMixMerge.fcl'

export conf=`sam_metadata_dumper g4_file | grep parents | sed s/\"parents\"// | sed s/': \[{\"file_name\":\"'// | sed s/'    '// | sed s/'"}],'//`

echo "Runnig overlay debug"
overlay_files.sh 2>&1 1>$log_file

rm -r overlay/

echo "Finished Overlay procedure"
