#!/bin/sh

# return the paths to online binaries needed to make and show plots of DSO output, to allow shifter to check before
# installing results in database

source ~/.bashrc
onlinesetup='setup_online'

if [ $1 == "1" ];then
$onlinesetup > /dev/null 2>&1
returnbin=`which setupNovaDBEnvVars.sh`
elif [ $1 == "2" ];then
$onlinesetup > /dev/null 2>&1
returnbin=`which printNovaDBEnvVars.sh`
elif [ $1 == "3" ];then
$onlinesetup > /dev/null 2>&1
returnbin=`which DumpEnableMasksAndThresholds`
elif [ $1 == "4" ];then
$onlinesetup > /dev/null 2>&1
returnbin=$NOVADAQ_ENVIRONMENT
else 
echo 'No path setups made. Please provide valid argument (1 - setupNovaDBEnvVars.sh, 2 - printNovaDBEnvVars.sh, 3-DumpEnableMasksAndThresholds 4-NOVADAQ_ENVIRONMENT'
exit 1
fi
echo $returnbin