#ifndef DAQ2RAWDIGIT_NOVAINPUTDRIVERBASE_H
#define DAQ2RAWDIGIT_NOVAINPUTDRIVERBASE_H
////////////////////////////////////////////////////////////////////////
/// \file  NOvA.h
/// \brief Source to convert raw binary files to root files
///
/// \version $Id: NOvAInputDriverBase.h,v 1.7 2012-11-18 18:52:46 gsdavies Exp $
////////////////////////////////////////////////////////////////////////
#include <string>

namespace daq2raw{


class NOvAInputDriverBase {

 public:
  NOvAInputDriverBase(std::string gdmlBase="");
  virtual ~NOvAInputDriverBase();

 protected:
  std::string getDetectorGDML(const int detid) const;

 private:
  std::string fGDMLBase;

};  // NOvAInputDriverBase

}//end of namespaces

#endif /* DAQ2RAWDIGIT_NOVAINPUTDRIVERBASE_H */


