////////////////////////////////////////////////////////////////////////
/// \brief   Vector container of FLSHit
///
/// \author  ishi@indiana.edu
/// \date
////////////////////////////////////////////////////////////////////////
#ifndef FLSHITLIST_H
#define FLSHITLIST_H
#include "Simulation/FLSHit.h"

namespace sim {
  /// A vector of FLSHit from single neutrino interaction
  class FLSHitList {
  public:
    FLSHitList();
    ~FLSHitList();
    
    bool Sort();
    
  public:
    std::vector<sim::FLSHit> fHits;

  };
}
#endif
////////////////////////////////////////////////////////////////////////
