#!/bin/bash

pushd results

printenv

SECTION=${PROCESS}
OUTDIR=${DEST}

export DATE=$(date +%y%m%d)

for FILE in *.root
  do
  echo "Attempting to transfer $FILE to $OUTDIR"
  FILENAME=${DATE}_${PROCESS}_${FILE}
  NEWDEST=${OUTDIR}/${FILENAME}
  echo "ifdh cp $FILE $NEWDEST"
  ifdh cp ${FILE} ${NEWDEST}
done

popd
