import sys
import os
import psycopg2

det=sys.argv[1]
lastrunFile = "lastrun{}".format(det)

if (det=='FarDet'):
    try:
        conn = psycopg2.connect("dbname=nova_prod host=ifdbrep.fnal.gov user=nova_reader port=5436")
    except:
        print "I am unable to connect to the database"
        exit(0)
else:
    try:
        conn = psycopg2.connect("dbname=nova_prod host=ifdbrep.fnal.gov user=nova_reader port=5434")
    except:
        print "I am unable to connect to the database"
        exit(0)
    
cur = conn.cursor()
    
f = open(lastrunFile,'r')
firstrun = int(f.readline())
f.close()

exceptionsFile = "exceptions"+det+".txt"
f = open(exceptionsFile,'r')
exceptionRuns = []
for line in f:
    exceptionRuns.append(int(line))
f.close()

#SQL = "select run,tstart,tstop from {}.runs where partition=1 and run>{} and nsubruns>4 order by run asc".format(det,firstrun)
SQL = "select run,tstart,tstop from {}.runs where partition=1 and run>{} and nsubruns>4 and tstart < 'yesterday' order by run asc".format(det,firstrun)
if (det=='NearDet'):
    SQL = "select run,tstart,tstop from {}.runs where run>{} and nsubruns>1 and tstart < 'yesterday' order by run asc".format(det,firstrun)

cur.execute(SQL)

rows = cur.fetchall()

irow=0
nrows = len(rows)

step=20
#if (det=='FarDet'):
#    step=10

for irow in range(0,nrows,step):

    rowList = rows[irow:irow+step]
    runList = []

    nrun = len(rowList)
    firstRun = rowList[0][0]
    lastRun = rowList[nrun-1][0]
#    cmd = "getBadChannels -phc {}_{}_{}.csv releases{}.txt {}".format(det,firstRun,lastRun,det,det)
    cmd = "getBadChannels -pdh releases{}.txt {}".format(det,det)

    for row in rowList:
        if row[0] in exceptionRuns:
            errorMsg = "Run {} found in the exceptions file.  Skipping.".format(row[0])
            print errorMsg
            continue
        tstop = row[2]
        if tstop is not None:
            cmd += " {}".format(row[0])
        else:
            errorMsg = "No stop time found for {} run {}.  Stopping now.".format(det,row[0])
            print errorMsg
            exit(9)

    print cmd
    result = os.system(cmd)
    if (result > 1) :
        print "Exit status: {}.  Aborting.".format(result)
        exit(result)

#    exit(0)

    f = open(lastrunFile,'w')
    f.write(str(lastRun))
    f.close()


