#include "HMatrixE/HMPid.h"

namespace hme
{

  HMPid::HMPid()
   : fLongChi2(-1)
   , fTransChi2(-1)
   , fCombChi2(-1)
   , fMIPHits(0) 
  {}

  //......................................................................  
  HMPid::~HMPid()
  {
  }

  void HMPid::SetLongChi2(double lchi2)
  {
    fLongChi2 = lchi2;
  }
  double HMPid::LongChi2() const
  {
    return fLongChi2;
  }

  void HMPid::SetTransChi2(double tchi2)
  {
    fTransChi2 = tchi2;
  }
  double HMPid::TransChi2() const
  {
    return fTransChi2;
  }

  void HMPid::SetCombChi2(double cchi2)
  {
    fCombChi2 = cchi2;
  }
  double HMPid::CombChi2() const
  {
    return fCombChi2;
  }

  void HMPid::SetMIPHits(double miphits)
  {
    fMIPHits = miphits;
  }
  double HMPid::MIPHits() const
  {
    return fMIPHits;
  }
}
  //......................................................................
