///////////////////////////////////////////////////////////////////////////////////////
///  
/// \brief  Nue Preselection Object
/// \author gsdavies@iu.edu 
///
///////////////////////////////////////////////////////////////////////////////////////
#include "Preselection/NuePreselObj.h"

namespace presel
{
  //----------------------------------------------------------------      
  NuePreselObj::NuePreselObj():
    fPassNuePresel(false)
  {
  }

  //----------------------------------------------------------------    
  NuePreselObj::~NuePreselObj()
  {
  }

  //----------------------------------------------------------------   
  void NuePreselObj::SetPassNuePresel(bool pass)
  {
    fPassNuePresel = pass;
  }
  
  //----------------------------------------------------------------
  bool NuePreselObj::PassNuePresel() const
  {
    return fPassNuePresel;
  }

} // end namespace presel
