#include "art/Persistency/Common/Wrapper.h" 

// Only include objects that we would like to be able to put into the event.
// Do not include the objects they contain internally.
//
#include "RawData/DAQHeader.h"
#include "RawData/FlatDAQData.h"
#include "RawData/RawDigit.h"
#include "RawData/RawTrigger.h"

template class std::vector<rawdata::DAQHeader>;
template class std::vector<rawdata::RawDigit>;
template class std::vector<rawdata::RawTrigger>;
template class std::vector<rawdata::FlatDAQData>;

template class art::Wrapper< rawdata::DAQHeader               >;
template class art::Wrapper< std::vector<rawdata::DAQHeader>  >;
template class art::Wrapper< std::vector<rawdata::RawDigit>   >;
template class art::Wrapper< std::vector<rawdata::RawTrigger> >;
template class art::Wrapper< std::vector<rawdata::FlatDAQData> >;
