////////////////////////////////////////////////////////////////////////
// \file    Energy.h
// \brief   Energy container. Base of other reconstruction classes.
// \version $Id: Energy.cxx,v 1.3 2012-10-26 18:40:17 rocco Exp $
// \author  $Author: rocco $
// \date    $Date: 2012-10-26 18:40:17 $
////////////////////////////////////////////////////////////////////////
#include "RecoBase/Energy.h"

namespace rb
{

  Energy::Energy():
  fE()
  {  }
  
  Energy::Energy(float energy):
  fE(energy)
  {  }

  void Energy::SetE(float Energy)
  {
    fE = Energy;
  }
  
  
  float Energy::E() const
  {
    return fE;
  }

  
  
} // end namespace
////////////////////////////////////////////////////////////////////////
