////////////////////////////////////////////////////////////////////////
// \file    SREnergyBranch.cxx
// \brief   An SREnergyBranch contains vectors of energy objects.                  
//          It is intended for use in the Common Analysis ROOT trees.
//
// \version $Id: SREnergyBranch.cxx,v 1.2 2012-11-19 17:32:22 rocco Exp $
// \author  $Author: rocco $
// \date    $Date: 2012-11-19 17:32:22 $
////////////////////////////////////////////////////////////////////////

#include "StandardRecord/SREnergyBranch.h"


namespace caf 
{
  
  SREnergyBranch::SREnergyBranch():
  numusimp(), 
  mutrkE(),
  elecid(),
  shwlid(),
  bpfenergy()
  {  }
  
  SREnergyBranch::~SREnergyBranch()
  {  }

  void SREnergyBranch::fillSizes()
  {
    nshwlid = shwlid.size();
  }
  
  
} // end namespace caf
////////////////////////////////////////////////////////////////////////
