////////////////////////////////////////////////////////////////////////
// \file    SRHoughVertex.cxx
// \brief   An  SRHoughVertex represents a potential interaction point.
// \version $Id: SRHoughVertex.cxx,v 1.5 2012-11-19 17:32:22 rocco Exp $
// \author  $Author: rocco $
// \date    $Date: 2012-11-19 17:32:22 $
////////////////////////////////////////////////////////////////////////
#include<limits>

#include "StandardRecord/SRHoughVertex.h"

namespace caf
{

  SRHoughVertex::SRHoughVertex():
    time(std::numeric_limits<float>::signaling_NaN()),
    vtx(std::numeric_limits<float>::signaling_NaN(),
        std::numeric_limits<float>::signaling_NaN(),
        std::numeric_limits<float>::signaling_NaN())
  {
  }

  SRHoughVertex::~SRHoughVertex()
  {
  }

} // end namespace caf
////////////////////////////////////////////////////////////////////////
