#include "TVector3.h"

#ifndef HOUGHPAIR_H
#define HOUGHPAIR_H

namespace zcl {
  class HoughPair;
}
class zcl::HoughPair {
 public:
  HoughPair(TVector3 p1, TVector3 p2);

  double const & getCosv()  const { return _cosv; };
  double const & getDoca()  const { return _doca; };

  double const & getDist()  const { return _dist; };
  double const & getVpro()  const { return _vpro; };

 private:
  // Computed data members
  double _cosv;
  double _doca;
  double _dist;
  double _vpro;

};

#endif
